<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] ?: array()) + array("_84718d828d2" . "acc3c366f96b" . "07e841f6a" => base64_decode("YWNsLnNpbX" . "BsZQ=="), "_27de5a45db71bf24058769b61b39" . "75a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5" . "vdCBzcGVjaWZpZWQ="), "_80fc2a45acd0150df" . "87d1fb728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0" . "hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5E" . "IHVzZXJfaWQ9aW50OnVpZA=="), "_938704c4c0169c3804d4bd" . "6aa9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdC" . "Bjb2RlIG5vdCBzcGVjaWZpZWQ="), "_ef2948c87ef38aab922" . "6e41189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY" . "3RfY29kZSBlcTpzdHI6Y29kZQ=="), "_0877a0b48cf424a0" . "de57a453ce95e30c" => base64_decode("aW50OnVzZXJfaWQ" . "="), "_a7ed4d7408bb99b87" . "a09d89d4212d5de" => base64_decode("c2ltcGxlX2FjbA" . "=="), "_dbbe14f567693a631f8a" . "43b65af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNlOiBvYmplY3QgY29kZSB" . "ub3Qgc3BlY2lmaWVk"), "_3cda3f34ada928e4aa3" . "9d4629c5504aa" => base64_decode("aW50OnJpZ2h0" . "cw=="), "_a8b22fed" . "b27a11e07" . "f5bb9a7c7" . "3608ea" => base64_decode("c3RyKDEwMCk6" . "b2JqZWN0X2Nv" . "ZGU="), "_c95cbc316" . "178c97697a" . "403f4d9124" . "106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2J" . "qZWN0X2NvZGUgZXE6c3RyOmNvZGU="), "_b06968b9268d" . "eaf3b380bd0fe" . "922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYm" . "plY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9p" . "ZD1pbnQ6dWlk"));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_84718d828d2" . "acc3c366f96b" . "07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_80fc2a45acd0150df" . "87d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_a7ed4d7408bb99b87a" . "09d89d4212d5de"], [$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_a8b22fedb27a" . "11e07f5bb9a7c" . "73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_0877a0b48cf424a0de57a453" . "ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_3cda3f34ada928e4" . "aa39d4629c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_b06968b9268deaf3b380bd0fe" . "922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_938704c4c" . "0169c3804d" . "4bd6aa9941" . "a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_c95cbc316178c97697a403f4d91" . "24106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_27de5a45db71bf240587" . "69b61b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_dbbe14f567" . "693a631f8a4" . "3b65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_ef2948c87ef38aab9226e41189" . "b29ca7"], $acl->GetObjectCode());
    }
}